﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace iceFinder
{
    class PowerState
    {
        double percentBattery;
        double remainingCapacity; //in watt-hours
        double currPower;
        double voltage;
        double current;
        double timeToFullEmpty; //time to full charge or discharge in minutes
        string batteryState;
        int leak; // 0 = noleak, 1 = leak

        public PowerState(string data)
        {
            string[] splitData;

            splitData = data.Split(new char[] {','});

            string[] messageEnd = splitData[8].Split(new char[] { '*' });

            percentBattery = Convert.ToDouble( splitData[1]);
            remainingCapacity = Convert.ToDouble( splitData[2]);
            currPower = Convert.ToDouble( splitData[3]);
            voltage = Convert.ToDouble( splitData[4]);
            current = Convert.ToDouble( splitData[5]);
            timeToFullEmpty = Convert.ToDouble(splitData[6]);
            batteryState = splitData[7];
            leak = Convert.ToInt32( messageEnd[0]);
        }

        public override string ToString()
        {
            return "Percent Battery Remaining: " + percentBattery.ToString() + 
                   " Remaining Capacity(watt-hours): " + remainingCapacity.ToString()
                   + " Current Power(watts): " + currPower.ToString() +
                   " Voltage(volts): " + voltage.ToString() +
                   " Current(amps): " + current.ToString() +
                   " Time to Full or Empty(minutes): " + timeToFullEmpty.ToString() +
                   " Battery State: " + batteryState +
                   " Leak: " + leak.ToString();
        }

        public string logString()
        {
            return percentBattery.ToString() + ";" + remainingCapacity.ToString() + ";" + currPower.ToString()
                   + ";" + voltage.ToString() + ";" + current.ToString() + ";" + timeToFullEmpty.ToString()
                   + ";" + batteryState + ";" + leak.ToString() + ";";
        }

        public double getPercentBattery()
        {
            return percentBattery;
        }
        public double getRemainingCapacity()
        {
            return remainingCapacity;
        }
        public double getCurrentPower()
        {
            return currPower;
        }
        public double getVoltage()
        {
            return voltage;
        }
        public double getCurrent()
        {
            return current;
        }
        public double getTimeToFullEmpty()
        {
            return timeToFullEmpty;
        }
        public string getBatteryState()
        {
            return batteryState;
        }
        public int getLeak()
        {
            return leak;
        }

    }
}
