﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;

namespace iceFinder
{
    class forceWaypoint
    {

        int wayPoint;
        SerialPort _aPort;
        string errorState;

        public forceWaypoint(int wp, SerialPort _port)
        {
            wayPoint = wp;
            _aPort = _port;
        }

        public string sendControl()
        {
            sendCommand(this.commandMessage(), _aPort);
            return errorState;
        }

        public void setNextWaypoint(int wp)
        {
            wayPoint = wp;
        }
        public void setPort(SerialPort _port)
        {
            _aPort = _port;
        }

        public int getWaypoint()
        {
            return wayPoint;
        }
        public SerialPort getPort()
        {
            return _aPort;
        }


        private void sendCommand(string command, SerialPort _port)
        {
            try
            {
                if (!(_port.IsOpen))
                {
                    _port.Open();
                }
                _port.Write(command);
                errorState = "noError";
            }
            catch (Exception e)
            {
                errorState = "Force Waypoint Error: " + e.Message;
            }
        }
        private string commandMessage()
        {
            string message;
            string cSum;

            message = "$OJW," + wayPoint.ToString() + "*";
            cSum = getCheckSum(message);
            message += cSum.Substring(1, 1) + cSum.Substring(2, 1) + "\r\n";
            return message;
        }
        private string getCheckSum(string com)
        {
            int checksum = 0;

            foreach (char c in com)
            {
                if (c == '$')
                {
                    //Ignore
                }
                else if (c == '*')
                {
                    break;
                }
                else
                {
                    if (checksum == 0)
                    {
                        checksum = Convert.ToByte(c);
                    }
                    else
                    {
                        checksum = checksum ^ Convert.ToByte(c);
                    }
                }
            }

            //string str = System.Uri.HexEscape((char)64);

            return System.Uri.HexEscape((char)checksum);
        }


    }
}
